/******************************************************************************
Ootake
E}EX傫Ƃ͉悤ɂB
E}EX̃Zbgpx𑝂₵āA̒xł茸炵B
E}EXgp̂Ƃ́AuWindows̃}EXJ[\vɃG~[^EBhE
  ̐^񒆂ɈʒuĉB悤ɂB
Eʂ̕\{ɂă}EX̊xœKB
E̓̌E-128ł͂Ȃ-127ǐEƓljɂB
E}EXzC[̉]ŃZNg{^(])E{^(])@\
  悤ɂBzC[(^񒆃{^)NbN邱ƂłA{^
  @\悤ɂB

Copyright(C)2006 Kitao Nakamura.
	ŁEpłJȂƂ͕K\[XR[hYtĂB
	̍ۂɎł܂܂̂ŁAЂƂƂm点ƍKłB
	Iȗp͋ւ܂B
	Ƃ́uGNU General Public License(ʌOp_)vɏ܂B

*******************************************************************************
	[Mouse.c]
		}EX܂B

	Copyright (C) 2004 Ki

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
******************************************************************************/
#include "Mouse.h"
#include "WinMain.h"
#include "Input.h"
#include "JoyPad.h"
#include "MainBoard.h" //Kitaoǉ


static Uint32	_ReadCount;
static Sint8	_DeltaX;
static Sint8	_DeltaY;
static Sint32	_CurrX;
static Sint32	_CurrY;
static Sint32	_PrevX;
static Sint32	_PrevY;
static BOOL		_bMsConnected = FALSE;
static Uint8	_ButtonState;
static Sint32	_ClockCounter;
static Uint32	_MouseWheelFlg = 0; //KitaoǉB}EXzC[̉]ŃZNgE{^ꂽꍇAZNgE{^𗣂̂߂ɕKvB


void
MOUSE_RButtonDown(
	BOOL		bDown)
{
	_ButtonState &= ~1;
	_ButtonState |= bDown;
}

void
MOUSE_LButtonDown(
	BOOL		bDown)
{
	_ButtonState &= ~2;
	_ButtonState |= bDown << 1;
}

void
MOUSE_SelButtonDown(
	BOOL		bDown)
{
	_ButtonState &= ~4;
	_ButtonState |= bDown << 2;
}

void
MOUSE_RunButtonDown(
	BOOL		bDown)
{
	_ButtonState &= ~8;
	_ButtonState |= bDown << 3;
}


void
MOUSE_Update(
	Sint32		x,
	Sint32		y)
{
	_CurrX = x;
	_CurrY = y;
}


void
MOUSE_Reset()
{
	if (_ClockCounter >= 7159090.0/60.0/16.0) //KitaoXVBx炷߁AZbgpx͌듮삵Ȃ͈͂łł邾B
	{
		_ReadCount = 0;
		_ClockCounter = 0;
	}
}


Uint8
MOUSE_ReadDelta()
{
	int		mag; //Kitaoǉ
	RECT	rc; //Kitaoǉ

	switch (_ReadCount++)
	{
		case 0: /* read delta x hi */
		{
			Sint32		dx;
			Sint32		dy;

			//KitaoXVBʂ̕\{ɂĊxœKB
			mag = MAINBOARD_GetMagnification();
			WINMAIN_GetMousePos(&_CurrX, &_CurrY);
			dx = (_PrevX - _CurrX) / mag;
			dy = (_PrevY - _CurrY) / mag;

			//KitaoXVB傫Ƃ͉悤ɂB
			if (dx>32)	dx += dx/2;
			if (dy>32)	dy += dy/2;
			if (dx<-32)	dx -= dx/2;
			if (dy<-32)	dy -= dy/2;

			if (dx > 127)	dx = 127;
			if (dy > 127)	dy = 127;
			if (dx < -127)	dx = -127; //KitaoXVB-128܂ŋƃ}EX傫񂵂Ƃɂ񂾂񍶂ɊĂ銴̂-127~܂ŁB
			if (dy < -127)	dy = -127; //KitaoXV

			//KitaoXVB}EXgp̂Ƃ́AuWindows̃}EXJ[\vɃG~[^EBhE̐^񒆂Ɉʒu悤ɂB
			GetWindowRect(WINMAIN_GetHwnd(), &rc);
			_PrevX = rc.left + (rc.right-rc.left)/2;
			_PrevY = rc.top + (rc.bottom-rc.top)/2;
			SetCursorPos(_PrevX, _PrevY);

			_DeltaX = (Sint8)dx;
			_DeltaY = (Sint8)dy;

//			printf("dx hi = %d\n", ((Uint8)_DeltaX) >> 4);

			return ((Uint8)_DeltaX) >> 4;
		}

		case 1: /* read delta x lo */
//			printf("dx lo = %d\n", ((Uint8)_DeltaX) & 0xf);
			return ((Uint8)_DeltaX) & 0xf;

		case 2: /* read delta y hi */
//			printf("dy hi = %d\n", ((Uint8)_DeltaY) >> 4);
			return ((Uint8)_DeltaY) >> 4;

		case 3: /* read delta y lo */
			_ReadCount = 0;
			_ClockCounter = 0;
//			printf("dy lo = %d\n", ((Uint8)_DeltaY) & 0xf);
			return ((Uint8)_DeltaY) & 0xf;
	}

	return 0;
}


Uint8
MOUSE_ReadButtons()
{
	Uint8	ret = _ButtonState;

	//WCpbhPSelect{^,Run{^󂯕t
	if (INPUT_IsPressed(1, JOYPAD_BUTTON_SELECT))	ret |= 4;
	if (INPUT_IsPressed(1, JOYPAD_BUTTON_RUN))		ret |= 8;

	//KitaoǉBSelect{^Run{^Xbvݒioô߂̋@\jȂB
	if (JOYPAD_GetSwapSelRun())
	{
		Uint8	a = ret;
		ret &= ~12;
		ret |= (a & 4)<<1;
		ret |= (a & 8)>>1;
	}

	//KitaoǉBI{^II{^Xbvݒi~OX̂߂̋@\jȂB
	if (JOYPAD_GetSwapIandII())
	{
		Uint8	a = ret;
		ret &= ~3;
		ret |= (a & 1)<<1;
		ret |= (a & 2)>>1;
	}

	return ret ^0xF;
}


inline void
MOUSE_Connect(
	BOOL		bConnect)
{
	_bMsConnected = bConnect;
}


inline BOOL
MOUSE_IsConnected()
{
	return _bMsConnected;
}


//KitaoXVBi߂NbN1NbNŒɂB
inline void
MOUSE_AdvanceClock()
{
	++_ClockCounter;

	if (_MouseWheelFlg > 0) //KitaoǉB}EXzC[̉]ŃZNg{^ƃ{^ꂽꍇ́A{^Xe[gNAB
		if (--_MouseWheelFlg == 0) //10ǂݏosꂽAZNg{^E{^ꂽƂɂB
			_ButtonState &= ~12;
}


//KitaoǉBzC[]ŃZNgE{^ƂɁAZNgE{^𗣂̂߂ɕKvB
void
MOUSE_SetMouseWheelFlg()
{
	_MouseWheelFlg = 7159090/3; //0.33bo߂AIɃZNg{^E{^悤ɂɂB
}

//Kitaoǉ
Uint32
MOUSE_GetMouseWheelFlg()
{
	return _MouseWheelFlg;
}


// save variable
#define SAVE_V(V)	if (fwrite(&V, sizeof(V), 1, p) != 1)	return FALSE
#define LOAD_V(V)	if (fread(&V, sizeof(V), 1, p) != 1)	return FALSE
/*-----------------------------------------------------------------------------
	[SaveState]
		Ԃt@Cɕۑ܂B 
-----------------------------------------------------------------------------*/
BOOL
MOUSE_SaveState(
	FILE*		p)
{
	if (p == NULL)
		return FALSE;

	SAVE_V(_ReadCount);
	SAVE_V(_DeltaX);
	SAVE_V(_DeltaY);
	SAVE_V(_CurrX);
	SAVE_V(_CurrY);
	SAVE_V(_PrevX);
	SAVE_V(_PrevY);
	SAVE_V(_bMsConnected);
	SAVE_V(_ButtonState);
	SAVE_V(_MouseWheelFlg); //Kitaoǉ

	return TRUE;
}


/*-----------------------------------------------------------------------------
	[LoadState]
		Ԃt@Cǂݍ݂܂B 
-----------------------------------------------------------------------------*/
BOOL
MOUSE_LoadState(
	FILE*		p)
{
	if (p == NULL)
		return FALSE;

	LOAD_V(_ReadCount);
	LOAD_V(_DeltaX);
	LOAD_V(_DeltaY);
	LOAD_V(_CurrX);
	LOAD_V(_CurrY);
	LOAD_V(_PrevX);
	LOAD_V(_PrevY);
	LOAD_V(_bMsConnected);
	LOAD_V(_ButtonState);
	LOAD_V(_MouseWheelFlg); //Kitaoǉ

	return TRUE;
}

#undef SAVE_V
#undef LOAD_V
